# Protocol Documentation
<a name="top"></a>

## Table of Contents

- [environments/environments_v1.proto](#environments_environments_v1-proto)
    - [EnvironmentData](#environments-EnvironmentData)
    - [EnvironmentFull](#environments-EnvironmentFull)
    - [EnvironmentId](#environments-EnvironmentId)
  
    - [Provider](#environments-Provider)
  
    - [Environments](#environments-Environments)
  
- [accounts/accounts_v1.proto](#accounts_accounts_v1-proto)
    - [AccountData](#accounts-AccountData)
    - [AccountFull](#accounts-AccountFull)
    - [AccountFullWithToken](#accounts-AccountFullWithToken)
    - [AccountId](#accounts-AccountId)
    - [AccountPassword](#accounts-AccountPassword)
    - [AccountWithPassword](#accounts-AccountWithPassword)
  
    - [Accounts](#accounts-Accounts)
  
- [Scalar Value Types](#scalar-value-types)



<a name="environments_environments_v1-proto"></a>
<p align="right"><a href="#top">Top</a></p>

## environments/environments_v1.proto
This file has messages for describing environments


<a name="environments-EnvironmentData"></a>

### EnvironmentData



| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| name | [string](#string) |  | Environment name |
| provider | [Provider](#environments-Provider) |  | Provide |






<a name="environments-EnvironmentFull"></a>

### EnvironmentFull



| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| id | [EnvironmentId](#environments-EnvironmentId) |  |  |
| data | [EnvironmentData](#environments-EnvironmentData) |  |  |






<a name="environments-EnvironmentId"></a>

### EnvironmentId
Represents a environment UUID only


| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| id | [string](#string) |  | Contour ID: UUID |





 


<a name="environments-Provider"></a>

### Provider


| Name | Number | Description |
| ---- | ------ | ----------- |
| Hetzner | 0 |  |


 

 


<a name="environments-Environments"></a>

### Environments
Service for handling environments

| Method Name | Request Type | Response Type | Description |
| ----------- | ------------ | ------------- | ------------|
| Create | [EnvironmentData](#environments-EnvironmentData) | [EnvironmentFull](#environments-EnvironmentFull) |  |
| Update | [EnvironmentFull](#environments-EnvironmentFull) | [EnvironmentFull](#environments-EnvironmentFull) |  |
| Delete | [EnvironmentFull](#environments-EnvironmentFull) | [.google.protobuf.Empty](#google-protobuf-Empty) |  |
| Get | [EnvironmentId](#environments-EnvironmentId) | [EnvironmentFull](#environments-EnvironmentFull) |  |
| List | [.google.protobuf.Empty](#google-protobuf-Empty) | [EnvironmentFull](#environments-EnvironmentFull) stream |  |

 



<a name="accounts_accounts_v1-proto"></a>
<p align="right"><a href="#top">Top</a></p>

## accounts/accounts_v1.proto
This file has messages for describing environments


<a name="accounts-AccountData"></a>

### AccountData



| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| name | [string](#string) |  | Account name |
| email | [string](#string) |  | Account email |






<a name="accounts-AccountFull"></a>

### AccountFull



| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| id | [AccountId](#accounts-AccountId) |  |  |
| data | [AccountData](#accounts-AccountData) |  |  |






<a name="accounts-AccountFullWithToken"></a>

### AccountFullWithToken



| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| id | [AccountId](#accounts-AccountId) |  |  |
| data | [AccountData](#accounts-AccountData) |  |  |
| Token | [string](#string) |  |  |






<a name="accounts-AccountId"></a>

### AccountId
Represents a environment UUID only


| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| id | [string](#string) |  | Contour ID: UUID |






<a name="accounts-AccountPassword"></a>

### AccountPassword



| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| Password | [string](#string) |  |  |






<a name="accounts-AccountWithPassword"></a>

### AccountWithPassword



| Field | Type | Label | Description |
| ----- | ---- | ----- | ----------- |
| data | [AccountData](#accounts-AccountData) |  |  |
| AccountPassword | [AccountPassword](#accounts-AccountPassword) |  |  |





 

 

 


<a name="accounts-Accounts"></a>

### Accounts
Service for handling environments

| Method Name | Request Type | Response Type | Description |
| ----------- | ------------ | ------------- | ------------|
| SignUp | [AccountWithPassword](#accounts-AccountWithPassword) | [AccountFullWithToken](#accounts-AccountFullWithToken) |  |
| SignIn | [AccountWithPassword](#accounts-AccountWithPassword) | [AccountFullWithToken](#accounts-AccountFullWithToken) |  |

 



## Scalar Value Types

| .proto Type | Notes | C++ | Java | Python | Go | C# | PHP | Ruby |
| ----------- | ----- | --- | ---- | ------ | -- | -- | --- | ---- |
| <a name="double" /> double |  | double | double | float | float64 | double | float | Float |
| <a name="float" /> float |  | float | float | float | float32 | float | float | Float |
| <a name="int32" /> int32 | Uses variable-length encoding. Inefficient for encoding negative numbers – if your field is likely to have negative values, use sint32 instead. | int32 | int | int | int32 | int | integer | Bignum or Fixnum (as required) |
| <a name="int64" /> int64 | Uses variable-length encoding. Inefficient for encoding negative numbers – if your field is likely to have negative values, use sint64 instead. | int64 | long | int/long | int64 | long | integer/string | Bignum |
| <a name="uint32" /> uint32 | Uses variable-length encoding. | uint32 | int | int/long | uint32 | uint | integer | Bignum or Fixnum (as required) |
| <a name="uint64" /> uint64 | Uses variable-length encoding. | uint64 | long | int/long | uint64 | ulong | integer/string | Bignum or Fixnum (as required) |
| <a name="sint32" /> sint32 | Uses variable-length encoding. Signed int value. These more efficiently encode negative numbers than regular int32s. | int32 | int | int | int32 | int | integer | Bignum or Fixnum (as required) |
| <a name="sint64" /> sint64 | Uses variable-length encoding. Signed int value. These more efficiently encode negative numbers than regular int64s. | int64 | long | int/long | int64 | long | integer/string | Bignum |
| <a name="fixed32" /> fixed32 | Always four bytes. More efficient than uint32 if values are often greater than 2^28. | uint32 | int | int | uint32 | uint | integer | Bignum or Fixnum (as required) |
| <a name="fixed64" /> fixed64 | Always eight bytes. More efficient than uint64 if values are often greater than 2^56. | uint64 | long | int/long | uint64 | ulong | integer/string | Bignum |
| <a name="sfixed32" /> sfixed32 | Always four bytes. | int32 | int | int | int32 | int | integer | Bignum or Fixnum (as required) |
| <a name="sfixed64" /> sfixed64 | Always eight bytes. | int64 | long | int/long | int64 | long | integer/string | Bignum |
| <a name="bool" /> bool |  | bool | boolean | boolean | bool | bool | boolean | TrueClass/FalseClass |
| <a name="string" /> string | A string must always contain UTF-8 encoded or 7-bit ASCII text. | string | String | str/unicode | string | string | string | String (UTF-8) |
| <a name="bytes" /> bytes | May contain any arbitrary sequence of bytes. | string | ByteString | str | []byte | ByteString | string | String (ASCII-8BIT) |

